import numpy as np
import math,sys,gzip,collections,gensim.models.doc2vec
from gensim.models import Doc2Vec
from collections import OrderedDict, namedtuple
import random, unicodedata, re
import datetime
sys.argv.pop(0)

f='doc2vecR.200.30.20.5.1550908281.eAp.trained' # THE TRAINED DOC2VEC MODEL
mod = Doc2Vec.load (f)

f=gzip.open('eAp.sPAD')

ms = {}
nl = 0
for line in f:
 l = line.rstrip().decode('ascii', 'ignore')
 all = l.split(';')
 st = all .pop(0)
 a = all .pop(0)
 m = all
 k = a
 if k not in ms: ms [k] = {}
 if m != '': ms [ k ][ st ] = m
 nl += 1

#print ('nrecords:' + str(nl))
ps = list()
dt = list(mod.docvecs.doctags)
for i in range(int(len(dt))):
 if '<' in dt[i] and '<' in dt[i] and '@' in dt[i]: ps .append(dt[i]);

def dist (av, bv):
 return (sum(av*bv)/math.sqrt(sum(av*av)*sum(bv*bv)))

for a in ms:
 if a in mod .docvecs:
  av = mod .docvecs [ a ]
  for m in ms [ a ][ '0' ]:
   if m in mod.docvecs:
    print (a+';0;'+m+';'+str(dist (mod.docvecs [ m ], av)))
  n1 = 0
  for m in ms [ a ][ '1' ]:
   if m in mod.docvecs:
    print (a+';1;'+m+';'+str(dist (mod.docvecs [ m ], av)))
  n1 += 1
  for m in random.sample (ps, n1):
   if m not in ms [ a ][ '1' ] and m not in ms [ a ][ '0' ]: print (a+';2;'+m+';'+str(dist (mod.docvecs [ m ], av)))
